
/********************************** (C) COPYRIGHT *******************************
 * File Name          : Uart.C
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2017/11/18
 * Description        : GPIO ʹúGPIOжʹʾ
 *******************************************************************************/
#include "CH552.H"
#include "Debug.H"
#include <stdio.h>
#include <string.h>
#include <intrins.h>
#include <rtx51tny.h> /* RTX-51 tiny functions & defines      */

#include "Usb.H"
#include "Main.H"

UINT8X Ep0Buffer[2 * THIS_ENDP0_SIZE] _at_ 0x0000;  //˵0 OUT&IN,˵4 INżַ
//80,C0,100,140
UINT8X Ep1Buffer[4 * THIS_ENDP0_SIZE] _at_ 0x0080; //˵1 OUT&IN˫,żַ
//180,1C0,200,240
UINT8X Ep2Buffer[4 * THIS_ENDP0_SIZE] _at_ 0x0180; //˵2 OUT&IN˫,żַ

PUINT8 pDescr; //USBñ־
UINT8I SetupReq, SetupLen, Ready, Count, UsbConfig;
#define UsbSetupBuf ((PUSB_SETUP_REQ)Ep0Buffer)

UINT16I USB_STATUS = 0;

/*******************************************************************************
 * Function Name  : USBDeviceInit()
 * Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
 * Input          : None
 * Output         : None
 * Return         : None
 *******************************************************************************/
void USBDeviceInit()
{
    IE_USB = 0;
    USB_CTRL = 0x00;        // 趨USB豸ģʽ
    UDEV_CTRL = bUD_PD_DIS; // ֹDP/DM
#ifndef Fullspeed
    UDEV_CTRL |= bUD_LOW_SPEED; //ѡ1.5Mģʽ
    USB_CTRL |= bUC_LOW_SPEED;
#else
    UDEV_CTRL &= ~bUD_LOW_SPEED; //ѡȫ12MģʽĬϷʽ
    USB_CTRL &= ~bUC_LOW_SPEED;
#endif

    UEP0_DMA = Ep0Buffer;                                      //˵0ݴַ
    UEP4_1_MOD |= bUEP4_TX_EN;                                 //˵064ֽշ˵464ֽڷͻ
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                 //OUT񷵻ACKIN񷵻NAK
    UEP4_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK;                 //˵4Զתͬ־λIN񷵻NAK

    UEP1_DMA = Ep1Buffer;                                      //˵1ݴַ
    UEP4_1_MOD |= bUEP1_TX_EN | bUEP1_RX_EN;                   //˵1ͽʹ
    UEP4_1_MOD |= bUEP1_BUF_MOD;                               //˵1շ˫64ֽڻ
    UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK; //˵1Զתͬ־λIN񷵻NAKOUTACK

    UEP2_DMA = Ep2Buffer;                                      //˵2ݴַ
    UEP2_3_MOD |= bUEP2_TX_EN | bUEP2_RX_EN;                   //˵2ͽʹ
    UEP2_3_MOD |= bUEP2_BUF_MOD;                               //˵2շ˫64ֽڻ
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK; //˵2Զתͬ־λIN񷵻NAKOUTACK

    USB_DEV_AD = 0x00;
    USB_CTRL |= bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN; // USB豸DMAжڼжϱ־δǰԶNAK
    UDEV_CTRL |= bUD_PORT_EN;                              // USB˿
    USB_INT_FG = 0xFF;                                     // жϱ־
    USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
    IE_USB = 1;
}
/*******************************************************************************
 * Function Name  : DeviceInterrupt()
 * Description    : CH552USBжϴ
 *******************************************************************************/
void DeviceInterrupt(void) interrupt INT_NO_USB using 1 //USBжϷ,ʹüĴ1
{
    UINT8 len;
    if (UIF_TRANSFER) // USBɱ־
    {
        switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
        {
        case UIS_TOKEN_OUT_EP1: // endpoint 1# ˵´ DAP-CMD
            if (U_TOG_OK)       // ͬݰ
            {
                
                UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_R_RES | UEP_R_RES_NAK;       //յһݾNAK꣬޸Ӧʽ
            }
            break;

        case UIS_TOKEN_IN_EP1: // endpoint 1# ˵ϴ DAP_ASK
            UEP1_T_LEN = 0;                                          //Ԥʹ÷ͳһҪ
            UEP1_CTRL &= ~MASK_UEP_T_RES | UEP_T_RES_NAK; //ĬӦNAK
            break;

        case UIS_TOKEN_OUT_EP2: // endpoint 2# ˵´ CDC
            if (U_TOG_OK)       // ͬݰ
            {
                
                UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_R_RES | UEP_R_RES_NAK;       //յһݾNAK꣬޸Ӧʽ
            }
            break;
            
        case UIS_TOKEN_IN_EP2: // endpoint 2# ˵ϴ CDC
            UEP2_T_LEN = 0;    //Ԥʹ÷ͳһҪ
            UEP2_CTRL &= ~MASK_UEP_T_RES | UEP_T_RES_NAK; //ĬӦNAK
            break;

        case UIS_TOKEN_IN_EP4: // endpoint4 IN
            UEP4_T_LEN = 0;    //Ԥʹ÷ͳһҪ
            UEP4_CTRL &= ~MASK_UEP_T_RES | UEP_T_RES_NAK; //ĬӦNAK
            break;
        
        case UIS_TOKEN_IN_EP0: // endpoint0 IN
            switch (SetupReq)
            {
            case USB_GET_DESCRIPTOR:
            case 0x20:
                len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; //δ䳤
                memcpy(Ep0Buffer, pDescr, len);                                 //ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG; //ͬ־λת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0; //״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;

        case UIS_TOKEN_OUT_EP0: // endpoint0 OUT
            len = USB_RX_LEN;
            if (SetupReq == 0x20) //ô
            {
                if (U_TOG_OK)
                {
                    memcpy(LineCoding, UsbSetupBuf, USB_RX_LEN);
//                    Config_Uart0(LineCoding);
                    UEP0_T_LEN = 0;
                    UEP0_CTRL |= UEP_R_RES_ACK | UEP_T_RES_ACK; // ׼ϴ0
                }
            }
            else
            {
                UEP0_T_LEN = 0;
                UEP0_CTRL |= UEP_R_RES_ACK | UEP_T_RES_NAK;  //״̬׶ΣINӦNAK
            }
            UEP0_CTRL ^= bUEP_R_TOG; //ͬ־λת
            break;

        case UIS_TOKEN_SETUP_EP0: // SETUP
            len = USB_RX_LEN;
            if (len == (sizeof(USB_SETUP_REQ)))
            {
                SetupLen = UsbSetupBuf->wLengthL;
//                if (UsbSetupBuf->wLengthH)
//                    SetupLen = 0xFF; // ܳ
                len = 0;             // ĬΪɹϴ0
                SetupReq = UsbSetupBuf->bRequest;
                switch (UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK)
                {
                case USB_REQ_TYP_STANDARD:
                    switch (SetupReq) //
                    {
                    case USB_GET_DESCRIPTOR:
                        switch (UsbSetupBuf->wValueH)
                        {
                        case USB_DESCR_TYP_DEVICE:               //豸
                            pDescr = DevDesc; //豸͵Ҫ͵Ļ
                            len = sizeof(DevDesc);
                            break;
                        case USB_DESCR_TYP_CONFIG:               //
                            pDescr = CfgDesc; //豸͵Ҫ͵Ļ
                            len = sizeof(CfgDesc);
                            break;
                        case USB_DESCR_TYP_STRING: // ַ
                            switch (UsbSetupBuf->wValueL)
                            {
                            case 0:
                                pDescr = (PUINT8)(&LangDescr[0]);
                                len = sizeof(LangDescr);
                                break;
                            case 1:
                                pDescr = (PUINT8)(&ManuInfo[0]);
                                len = sizeof(ManuInfo);
                                break;
                            case 2:
                                pDescr = (PUINT8)(&ProdInfo[0]);
                                len = sizeof(ProdInfo);
                                break;
                            case 3:
                                pDescr = (PUINT8)(&SerNumber[0]);
                                len = sizeof(SerNumber);
                                break;
                            case 4:
                                pDescr = (PUINT8)(&DAPInfo[0]);
                                len = sizeof(DAPInfo);
                                break;
                            case 5:
                                pDescr = (PUINT8)(&CDCInfo[0]);
                                len = sizeof(CDCInfo);
                                break;
                            default:
                                len = 0xFF; // ֵַ֧
                                break;
                            }
                            break;
                        case USB_DESCR_TYP_BOS:
                            pDescr = (PUINT8)(&BOSDesc[0]);
                            len = sizeof(BOSDesc);
                            break;
                        default:
                            len = 0xff; //ֵ֧߳
                            break;
                        }
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL; //ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if (SetupLen >= 1)
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
                        if (UsbConfig)
                        {
                            Ready = 1; // set configһusböɵı־
                        }
                        break;
                    case 0x0A:
                        break;
                    case USB_CLEAR_FEATURE:                                                         // Clear Feature
                        if ((UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP) // ˵
                        {
                            switch (UsbSetupBuf->wIndexL)
                            {
                            case 0x81:
                                UEP1_CTRL = UEP1_CTRL & ~(bUEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                break;
                            case 0x01:
                                UEP1_CTRL = UEP1_CTRL & ~(bUEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                                break;
                            case 0x82:
                                UEP2_CTRL = UEP2_CTRL & ~(bUEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                break;
                            case 0x02:
                                UEP2_CTRL = UEP2_CTRL & ~(bUEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                                break;
                            case 0x84:
                                UEP4_CTRL = UEP4_CTRL & ~(bUEP_R_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                break;
                            default:
                                len = 0xFF; // ֵ֧Ķ˵
                                break;
                            }
                        }
                        else
                        {
                            len = 0xFF; // Ƕ˵㲻֧
                        }
                        break;
                    case USB_SET_FEATURE:                               /* Set Feature */
                        if ((UsbSetupBuf->bRequestType & 0x1F) == 0x00) /* 豸 */
                        {
                            if ((((UINT16)UsbSetupBuf->wValueH << 8) | UsbSetupBuf->wValueL) == 0x01)
                            {
                                if (CfgDesc[7] & 0x20)
                                {
                                    /* ûʹܱ־ */
                                }
                                else
                                {
                                    len = 0xFF; /* ʧ */
                                }
                            }
                            else
                            {
                                len = 0xFF; /* ʧ */
                            }
                        }
                        else if ((UsbSetupBuf->bRequestType & 0x1F) == 0x02) /* ö˵ */
                        {
                            if ((((UINT16)UsbSetupBuf->wValueH << 8) | UsbSetupBuf->wValueL) == 0x00)
                            {
                                switch (((UINT16)UsbSetupBuf->wIndexH << 8) | UsbSetupBuf->wIndexL)
                                {
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL; /* ö˵1 IN STALL */
                                    break;
                                case 0x01:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL; /* ö˵1 OUT STALL */
                                    break;
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL; /* ö˵2 IN STALL */
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL; /* ö˵2 OUT STALL */
                                    break;
                                case 0x84:
                                    UEP4_CTRL = UEP4_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL; /* ö˵3 IN STALL */
                                    break;
                                default:
                                    len = 0xFF; /* ʧ */
                                    break;
                                }
                            }
                            else
                            {
                                len = 0xFF; /* ʧ */
                            }
                        }
                        else
                        {
                            len = 0xFF; /* ʧ */
                        }
                        break;
                    case USB_GET_STATUS:
                        pDescr = (PUINT8)&USB_STATUS;
                        if (SetupLen >= 2)
                        {
                            len = 2;
                        }
                        else
                        {
                            len = SetupLen;
                        }
                        break;
                    default:
                        len = 0xff; //ʧ
                        break;
                    }

                    break;
                case USB_REQ_TYP_CLASS: /*HID*/
                    if ((UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_INTERF)
                    {
                        switch (SetupReq)
                        {
                        case 0x01://GetReport
                            break;
                        case GET_LINE_CODING:   //0x21  currently configured
                            pDescr = LineCoding;
                            len = sizeof(LineCoding);
                            break;
                        case SET_CONTROL_LINE_STATE:  //0x22  generates RS-232/V.24 style control signals
                            break;
                        case SET_LINE_CODING:      //0x20  Configure
                            break;
                        default:
                            len = 0xFF; /*֧*/
                            break;
                        }
                    }
                    break;
                case USB_REQ_TYP_VENDOR:
                    if ((UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_DEVICE)
                    {
                        switch (SetupReq)
                        {
                        case 0x20: // GetReport
                            if (UsbSetupBuf->wIndexL == 0x07)
                            {
                                pDescr = WINDesc; //豸͵Ҫ͵Ļ
                                len = sizeof(WINDesc);
                            }
                            break;
                        default:
                            len = 0xFF; /*֧*/
                            break;
                        }
                    }
                    break;
                default:
                    len = 0xFF;
                    break;
                }
                if (len != 0 && len != 0xFF)
                {
                    if (SetupLen > len)
                    {
                        SetupLen = len; //ܳ
                    }
                    len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; //δ䳤
                    memcpy(Ep0Buffer, pDescr, len);                                 //ϴ
                    SetupLen -= len;
                    pDescr += len;
                }
            }
            else
            {
                len = 0xff; //ȴ
            }
            if (len == 0xff)
            {
                SetupReq = 0xFF;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL; // STALL
            }
            else if (len <= THIS_ENDP0_SIZE) //ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK; //ĬݰDATA1ӦACK
            }
            else
            {
                UEP0_T_LEN = 0;                                                      //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK; //ĬݰDATA1,ӦACK
            }
            break;
            
        default:
            break;
        }
        UIF_TRANSFER = 0; //д0ж
    }
    if (UIF_BUS_RST) //豸ģʽUSB߸λж
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP4_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0; //жϱ־
    }
    if (UIF_SUSPEND) // USB߹/
    {
        UIF_SUSPEND = 0;
        if (USB_MIS_ST & bUMS_SUSPEND) //
        {
        }
    }
    else
    {
        //ж,ܷ
        USB_INT_FG = 0xFF; //жϱ־
    }
}

/******************************************************************************/
/*       Task 2 'usb_task'                                                   */
/******************************************************************************/
void Usb_Task (void) _task_ USB {
    USBDeviceInit();
    printf("USB task\n");
    while (1)
    {               /* endless loop                         */
        os_wait(K_TMO, 100, 0);            /* wait for timeout: 100 ticks            */
    }
}